<script setup lang="ts">
import { onMounted, ref, computed } from 'vue'

import { useStockStore } from '@/stores/stock';
import { useStockDetailStore } from '@/stores/stockDetail';
import type { StockDetail } from '@/types/StockDetail';
import { useMaterialStore } from '@/stores/material';

onMounted(async () => {
    await stockStore.getStocks()
    await materialStore.getMaterials()
    await stockDetailStore.getStockDetailsByStockId(stockStore.stocks[stockStore.stocks.length - 1].id)
    laststockDetails.value = stockDetailStore.stockDetails
})

const Matsheaders = [
    {
        title: 'รหัสของรายละเอียดในสต็อก',
        key: 'id',
        value: 'id',
        width: '300px'
    },
    {
        title: 'ชื่อวัตถุดิบ',
        key: 'material id',
        value: 'material id',
        width: '300px'
    },
    {
        title: 'ส่วนต่างของปริมาณกับขีดต่ำสุด',
        key: 'balance',
        value: 'balance',
        width: '300px'
    }, {
        title: 'หน่วย',
        key: 'type',
        value: 'type',
        width: '100px'
    }
]

const stockStore = useStockStore()
const stockDetailStore = useStockDetailStore()
const materialStore = useMaterialStore()

const laststockDetails = ref<StockDetail[]>([])

function refresh() {
    console.log('stockDetailStore.stockDetails', stockDetailStore.stockDetails)
}
function findTypeMat(materialId: number) {
    for (const sd of stockDetailStore.stockDetails) {
        const findMat = materialStore.materials.find((mat) => mat.id === materialId)

        if (findMat) {
            return findMat.type
        } else {
            return 'Unit'
        }

    }
}
const balanceColor = computed(() => {
    return (balance: number) => {
        if (balance === 5) {
            return 'orange';
        } else if (balance > 0) {
            return 'green';
        } else {
            return 'red';
        }
    };
});
</script>


<template>
    <v-sheet>
        <v-toolbar class="custom-stock-toolbar" v-if="laststockDetails">
            <v-toolbar-title style="font-size: 24px; color: #5865f2"> The Latest Check Stock </v-toolbar-title>
        </v-toolbar>

        <v-data-table :items="laststockDetails" :headers="Matsheaders" class="elevation-1 custom-table" fixed-header
            height="350px">
            <template v-slot:item="props">
                <tr>
                    <td>{{ props.item.id }}</td>
                    <td>{{ stockDetailStore.getMaterialName(props.item.materialId) }}</td>
                    <!-- Apply style attribute dynamically to change text color based on balance -->
                    <td><v-chip :color="balanceColor(props.item.balance)">{{ props.item.balance }}</v-chip></td>
                    <td>{{ findTypeMat(props.item.materialId) }}</td>
                </tr>
            </template>
        </v-data-table>
    </v-sheet>
</template>
